local H_PROTRACK = {}

H_PROTRACK.Main = CreateFrame("Frame");

H_PROTRACK.Select = CreateFrame("Frame", "ProTrackSelect", TradeSkillFrame);
H_PROTRACK.Select:SetSize(470, 90)
H_PROTRACK.Select:SetBackdrop( { 
    bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
    tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
});
H_PROTRACK.Select:Hide()

H_PROTRACK.Select.CheckBoxes = {}
H_PROTRACK.Select.Buttons = CreateFrame("Frame", "ProTrackSelectButtons", H_PROTRACK.Select)
H_PROTRACK.Select.Buttons:SetSize(70, 70)
H_PROTRACK.Select.Buttons:SetPoint("TOPRIGHT",-10, -10)
H_PROTRACK.Select.Buttons.ToggleTracker = CreateFrame("Button", "ProTrackSelectButtonsToggleTracker", H_PROTRACK.Select.Buttons, "ProTrackButtonTemplate")
H_PROTRACK.Select.Buttons.ToggleTracker:SetPoint("TOPRIGHT", 0, 0)
H_PROTRACK.Select.Buttons.ToggleTracker:SetText("Toggle")
H_PROTRACK.Select.Buttons.ToggleTracker.tooltipText ="Toggle the ProTrack widget"
H_PROTRACK.Select.Buttons.ToggleTracker:RegisterForClicks("AnyUp")
H_PROTRACK.Select.Buttons.ToggleTracker:SetScript("OnClick", function (self)
    H_PROTRACK.H_ToggleTracker()
end)

H_PROTRACK.Tracker = CreateFrame("Frame", "ProTrackTracker", UIParent)
H_PROTRACK.Tracker.Header = CreateFrame("Frame", "ProTrackTrackerHeader", H_PROTRACK.Tracker)
H_PROTRACK.Tracker.Header:SetPoint("TOPLEFT", 0, 0)
H_PROTRACK.Tracker.Header:SetSize(250, 25)
H_PROTRACK.Tracker.Header.text = H_PROTRACK.Tracker.Header:CreateFontString("FontString",  "OVERLAY", "GameFontNormal")
H_PROTRACK.Tracker.Header.text:SetPoint("LEFT", 10, -2)

H_PROTRACK.Tracker.Header.text:SetTextColor(1.0, 1.0, 1.0, 1.0)
H_PROTRACK.Tracker.Header.text:SetText("ProTrack")

H_PROTRACK.Tracker.Header.Tabs = {}
H_PROTRACK.Tracker.ListItem = {}

H_PROTRACK.Tracker:SetSize(250, 30);
H_PROTRACK.Tracker:SetBackdrop( { 
    bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
    tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
});

H_PROTRACK.Tracker.Header:EnableMouse(true)
H_PROTRACK.Tracker.Header:RegisterForDrag("LeftButton")
    
H_PROTRACK.Tracker.Header:SetScript("OnDragStart",  function(self, button)
    H_PROTRACK.Tracker:StartMoving()
end)
    
H_PROTRACK.Tracker.Header:SetScript("OnDragStop", function(self, button)
    H_PROTRACK.Tracker:StopMovingOrSizing()
    HENKIB_SV_PROTRACK_CHAR.TrackerPoint = select (1, H_PROTRACK.Tracker:GetPoint())
    HENKIB_SV_PROTRACK_CHAR.TrackerReferencePoint = select (3, H_PROTRACK.Tracker:GetPoint())
    HENKIB_SV_PROTRACK_CHAR.TrackerX = math.floor(select (4, H_PROTRACK.Tracker:GetPoint()))
    HENKIB_SV_PROTRACK_CHAR.TrackerY = math.floor(select (5, H_PROTRACK.Tracker:GetPoint()))
end)
    
H_PROTRACK.Tracker.Header:SetScript("OnHide", function(self, button)
    H_PROTRACK.Tracker:StopMovingOrSizing()
    HENKIB_SV_PROTRACK_CHAR.Show = false;
end)

H_PROTRACK.Tracker:SetMovable(true)

function H_PROTRACK.H_StartProTrack()
    
    local function eventHandler(self, event, arg1)

        if (event == "TRADE_SKILL_LIST_UPDATE") then

            if(C_TradeSkillUI.IsTradeSkillLinked()) then

            elseif (C_TradeSkillUI.IsTradeSkillGuild()) then

            elseif (C_TradeSkillUI.IsNPCCrafting()) then

            else
                H_PROTRACK.H_ShowSelectWindow()
            end

        elseif (event == "CHAT_MSG_SKILL") then
            H_PROTRACK.H_AddSkillpoint(arg1)
        elseif (event == "TRADE_SKILL_CLOSE") then
            H_PROTRACK.H_CloseSelectWindow()
        end
		
    end

    if C_TradeSkillUI.GetCategories() == nil then
        --print("No skill data loaded")
    end

    H_PROTRACK.Main:RegisterEvent("TRADE_SKILL_LIST_UPDATE")
    H_PROTRACK.Main:RegisterEvent("CHAT_MSG_SKILL")
    H_PROTRACK.Main:RegisterEvent("TRADE_SKILL_CLOSE")
    H_PROTRACK.Main:SetScript("OnEvent", eventHandler)

    H_PROTRACK.H_CreateTracker()
    H_PROTRACK.H_UpdateTracker()

end

function H_PROTRACK.H_CreateTracker()

    if (HENKIB_SV_PROTRACK_CHAR["TrackerPoint"] == nil) then
        H_PROTRACK.Tracker:SetPoint("CENTER", nil, "CENTER", 0, 0)
    else 
        H_PROTRACK.Tracker:SetPoint(HENKIB_SV_PROTRACK_CHAR.TrackerPoint, nil, HENKIB_SV_PROTRACK_CHAR.TrackerReferencePoint, HENKIB_SV_PROTRACK_CHAR.TrackerX, HENKIB_SV_PROTRACK_CHAR.TrackerY)
    end

    if (HENKIB_SV_PROTRACK_CHAR["TrackerVisible"] ~= nil) then
        if HENKIB_SV_PROTRACK_CHAR.TrackerVisible then
            H_PROTRACK.H_ShowTracker()
        else
            H_PROTRACK.H_ShowTracker()
        end
    end

    if (HENKIB_SV_PROTRACK_CHAR["Collapsed"] == nil) then
        HENKIB_SV_PROTRACK_CHAR.Collapsed = false
    end

    H_PROTRACK.Tracker.Header.CloseButton = CreateFrame("BUTTON", "ProTrackTrackerButton", H_PROTRACK.Tracker.Header, "ProTrackCloseButtonTemplate");
    H_PROTRACK.Tracker.Header.CloseButton:SetPoint("TOPRIGHT",-2,-2)
    H_PROTRACK.Tracker.Header.CloseButton:RegisterForClicks("AnyUp")
    H_PROTRACK.Tracker.Header.CloseButton:SetScript("OnClick", function (self)
        H_PROTRACK.H_HideTracker()
    end)

    H_PROTRACK.Tracker.Header.CollapseButton = CreateFrame("BUTTON", "ProTrackTrackerButton", H_PROTRACK.Tracker.Header, "ProTrackCollapseButtonTemplate");
    H_PROTRACK.Tracker.Header.CollapseButton:SetPoint("TOPRIGHT",-15,-2)
    H_PROTRACK.Tracker.Header.CollapseButton:RegisterForClicks("AnyUp")
    H_PROTRACK.Tracker.Header.CollapseButton:SetScript("OnClick", function (self)
        H_PROTRACK.H_ToggleCollapse()
    end)

    H_PROTRACK.Tracker.NoData = CreateFrame("Frame", "ProTrackTracker", H_PROTRACK.Tracker);
    H_PROTRACK.Tracker.NoData:SetPoint("TOPLEFT", 10, -35)
    H_PROTRACK.Tracker.NoData:SetSize(1,1)
    H_PROTRACK.Tracker.NoData.Text = H_PROTRACK.Tracker.NoData:CreateFontString(H_PROTRACK.Tracker.NoData, "OVERLAY", "GameFontNormalSmall")
    H_PROTRACK.Tracker.NoData.Text:SetPoint("TOPLEFT", 0, 0)
    H_PROTRACK.Tracker.NoData:Hide()

    y = -5
    x = -37
    for _, index in pairs({GetProfessions()}) do
        if index ~= 9 then 
            name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(index)
            H_PROTRACK.Tracker.Header.Tabs[skillLine] = CreateFrame("BUTTON", "ProTrackTrackerButton", H_PROTRACK.Tracker.Header, "SecureHandlerClickTemplate");
            H_PROTRACK.Tracker.Header.Tabs[skillLine].name = name;
            H_PROTRACK.Tracker.Header.Tabs[skillLine].skillLine = skillLine;
            H_PROTRACK.Tracker.Header.Tabs[skillLine]:SetSize(20,20)
            H_PROTRACK.Tracker.Header.Tabs[skillLine]:SetPoint("TOPRIGHT",x,y)
            H_PROTRACK.Tracker.Header.Tabs[skillLine]:RegisterForClicks("AnyUp")
            H_PROTRACK.Tracker.Header.Tabs[skillLine]:SetScript("OnClick", H_PROTRACK.H_OpenTradeSkill)
            local texture = H_PROTRACK.Tracker.Header.Tabs[skillLine]:CreateTexture(nil,"BACKGROUND",nil,-6)
            texture:SetTexture(icon)
            texture:SetTexCoord(0.1,0.9,0.1,0.9)
            texture:SetAllPoints( H_PROTRACK.Tracker.Header.Tabs[skillLine])
            x = x - 22
        end
    end
end

function H_PROTRACK.H_OpenTradeSkill(self)
    C_TradeSkillUI.OpenTradeSkill(self.skillLine)
end


function H_PROTRACK.H_ShowSelectWindow()
    H_PROTRACK.H_CreateSelectCheckBoxes()
    H_PROTRACK.H_UpdateTracker()
    print(TradeSkillFrame)
    if (TradeSkillFrame == nil) then
        H_PROTRACK.Select:SetPoint("CENTER", UIParent, "TOP", 0, -90)
    elseif TradeSkillFrame:IsVisible() then
        H_PROTRACK.Select:SetPoint("BOTTOM", TradeSkillFrame, "BOTTOM", 0, -85)
    else
        H_PROTRACK.Select:SetPoint("CENTER", TradeSkillFrame, "TOP", 0, -90)
    end
    H_PROTRACK.Select:Show()

end

function H_PROTRACK.H_CreateSelectCheckBoxes()

    y = -9
    x = 10
    i = 1

    for categoryID, _ in pairs(HENKIB_SV_PROTRACK_CHAR.Selected) do 
        HENKIB_SV_PROTRACK_CHAR.Selected[categoryID].isLoaded = false
    end

    for i, _ in pairs(H_PROTRACK.Select.CheckBoxes) do
        H_PROTRACK.Select.CheckBoxes[i]:Hide()
    end
    
    for _, categoryID in pairs({C_TradeSkillUI.GetCategories()}) do

        local data = {}
        C_TradeSkillUI.GetCategoryInfo(categoryID, data)
        
        if (data.skillLineCurrentLevel ~= nil) then

            

            if (i % 6 == 0) then
                y = -9;
                x = x + 170
            end

            if (H_PROTRACK.Select.CheckBoxes[data.categoryID] == nil) then
                
                H_PROTRACK.H_CreateSelectCheckbox(data);

            else 
                H_PROTRACK.Select.CheckBoxes[data.categoryID]:Show()
            end

            H_PROTRACK.Select.CheckBoxes[data.categoryID]:SetPoint("TOPLEFT", H_PROTRACK.Select, "TOPLEFT", x, y)

            if (data.skillLineMaxLevel > 1) then
                H_PROTRACK.Select.CheckBoxes[data.categoryID]:Enable() 
                H_PROTRACK.Select.CheckBoxes[data.categoryID].Font:SetText(data.skillLineCurrentLevel.."/"..data.skillLineMaxLevel.." "..data.name)
                H_PROTRACK.Select.CheckBoxes[data.categoryID].Font:SetTextColor(1.0, 0.9, 0.0, 1.0)
            else
                H_PROTRACK.Select.CheckBoxes[data.categoryID]:Disable()
                H_PROTRACK.Select.CheckBoxes[data.categoryID].Font:SetText("*/* "..data.name)
                H_PROTRACK.Select.CheckBoxes[data.categoryID].Font:SetTextColor(1.0, 1.0, 1.0, 0.2)
            end

            _, _, _, _, _, parentSkillLineID, _ = C_TradeSkillUI.GetTradeSkillLine()
            H_PROTRACK.H_SaveProfTrackData(data, H_PROTRACK.Select.CheckBoxes[data.categoryID]:GetChecked(), i .. parentSkillLineID)
            
            y = y - 15;
            i = i + 1 

        end
        
    end

end

function H_PROTRACK.H_SaveProfTrackData(data, checked, order)

    HENKIB_SV_PROTRACK_CHAR.Selected[data.categoryID] = data
    HENKIB_SV_PROTRACK_CHAR.Selected[data.categoryID].isChecked = checked
    HENKIB_SV_PROTRACK_CHAR.Selected[data.categoryID].isLoaded = true
    HENKIB_SV_PROTRACK_CHAR.Selected[data.categoryID].order = order

end

function H_PROTRACK.H_CloneTable(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in pairs(orig) do
            copy[orig_key] = orig_value
        end
    else
        copy = orig
    end
    return copy
end

function H_PROTRACK.H_UpdateProfTrackData()

    local data = {}

    for _, categoryID in pairs({C_TradeSkillUI.GetCategories()}) do
        C_TradeSkillUI.GetCategoryInfo(categoryID, data)

        if (data.skillLineCurrentLevel ~= nil) then

            if HENKIB_SV_PROTRACK_CHAR.Metrics[categoryID] == nil then
                H_PROTRACK.H_CreateMetrics(data)
            end

            if HENKIB_SV_PROTRACK_CHAR.Metrics[categoryID].skillLineLastLevel < data.skillLineCurrentLevel then

                table.insert(HENKIB_SV_PROTRACK_CHAR.Metrics[categoryID].timestamps, 1, time() - HENKIB_SV_PROTRACK_CHAR.Metrics[categoryID].lastTimestamp)

                HENKIB_SV_PROTRACK_CHAR.Metrics[categoryID].lastTimestamp = time()

                local midValu

                if (table.getn(HENKIB_SV_PROTRACK_CHAR.Metrics[categoryID].timestamps) > 20) then
                    table.remove(HENKIB_SV_PROTRACK_CHAR.Metrics[categoryID].timestamps)
                end

                local tableCopy = H_PROTRACK.H_CloneTable(HENKIB_SV_PROTRACK_CHAR.Metrics[categoryID].timestamps);
                local x = math.floor(table.getn(tableCopy) / 9)

                table.sort(tableCopy)

                for i = x, 1, -1 do 
                    table.remove(tableCopy, 1)
                    table.remove(tableCopy)
                end

                local numberOfEntries = table.getn(tableCopy)
                local entryValues = 0

                for i, v in pairs(tableCopy) do
                    entryValues = entryValues + v
                end

                local meanValue = entryValues / numberOfEntries
                local skillPerHour = math.floor(3600 / meanValue)

                HENKIB_SV_PROTRACK_CHAR.Metrics[categoryID].skillPerHour = skillPerHour

                HENKIB_SV_PROTRACK_CHAR.Metrics[categoryID].skillLineLastLevel = data.skillLineCurrentLevel 

            end

            HENKIB_SV_PROTRACK_CHAR.Selected[categoryID].skillLineCurrentLevel = data.skillLineCurrentLevel
        end
    end

end

function H_PROTRACK.H_CreateMetrics(data)

    HENKIB_SV_PROTRACK_CHAR.Metrics[data.categoryID] = {
        ["skillLineLastLevel"] = data.skillLineCurrentLevel,
        ["skillPerHour"] = nil,
        ["lastTimestamp"] = time(),
        ["timestamps"] = { }
    }

end

function H_PROTRACK.H_ResetMetrics()

    HENKIB_SV_PROTRACK_CHAR.Metrics = {}

end



function H_PROTRACK.H_CreateSelectCheckbox(data, x, y)
    H_PROTRACK.Select.CheckBoxes[data.categoryID] = CreateFrame("CheckButton", "H_PROTRACK_Select_Checkbox" .. data.categoryID, H_PROTRACK.Select, "ProTrackBaseCheckButtonTemplate")
    H_PROTRACK.Select.CheckBoxes[data.categoryID].categoryID = data.categoryID
    H_PROTRACK.Select.CheckBoxes[data.categoryID].Font = H_PROTRACK.Select.CheckBoxes[data.categoryID]:CreateFontString(H_PROTRACK.Select.CheckBoxes[data.categoryID], "OVERLAY", "GameFontNormalTiny2")
    H_PROTRACK.Select.CheckBoxes[data.categoryID].Font:SetPoint("LEFT", 17, 0)
    H_PROTRACK.Select.CheckBoxes[data.categoryID]:RegisterForClicks("AnyUp")
    H_PROTRACK.Select.CheckBoxes[data.categoryID]:SetScript("OnClick", H_PROTRACK.H_AddToSelected)
    if (HENKIB_SV_PROTRACK_CHAR.Selected[data.categoryID] ~= nil) then
        if HENKIB_SV_PROTRACK_CHAR.Selected[data.categoryID].isChecked then
            H_PROTRACK.Select.CheckBoxes[data.categoryID]:SetChecked(true)
        end
    end

end

function H_PROTRACK.H_CreateTrackerLine(data)

    H_PROTRACK.Tracker.ListItem[data.categoryID] = CreateFrame("Frame", "H_PROTRACK_Tracker_List_Item", H_PROTRACK.Tracker);
    H_PROTRACK.Tracker.ListItem[data.categoryID]:SetSize(235, 1)
    H_PROTRACK.Tracker.ListItem[data.categoryID].isLoaded = data.isLoaded
    H_PROTRACK.Tracker.ListItem[data.categoryID].name = H_PROTRACK.Tracker.ListItem[data.categoryID]:CreateFontString("FontString",  "OVERLAY", "GameFontNormalSmall")
    H_PROTRACK.Tracker.ListItem[data.categoryID].name:SetPoint("LEFT", 0, 0)
    H_PROTRACK.Tracker.ListItem[data.categoryID].name:SetTextColor(1.0, 1.0, 1.0, 1.0)
    H_PROTRACK.Tracker.ListItem[data.categoryID].skillPoints = H_PROTRACK.Tracker.ListItem[data.categoryID]:CreateFontString("FontString",  "OVERLAY", "GameFontNormalSmall")
    H_PROTRACK.Tracker.ListItem[data.categoryID].skillPoints:SetPoint("RIGHT", 0, 0)
    H_PROTRACK.Tracker.ListItem[data.categoryID].skillPoints:SetTextColor(1.0, 0.9, 0.0, 1.0)
    H_PROTRACK.Tracker.ListItem[data.categoryID].skillPerHour = H_PROTRACK.Tracker.ListItem[data.categoryID]:CreateFontString("FontString",  "OVERLAY", "GameFontNormalSmall")
    H_PROTRACK.Tracker.ListItem[data.categoryID].skillPerHour:SetPoint("RIGHT", -55, 0)
    H_PROTRACK.Tracker.ListItem[data.categoryID].skillPerHour:SetTextColor(1.0, 0.9, 0.0, 1.0)
    H_PROTRACK.Tracker.ListItem[data.categoryID]:Hide()

end


function H_PROTRACK.H_CloseSelectWindow()

    H_PROTRACK.Select:Hide()
 
end

function H_PROTRACK.H_AddToSelected(self)
    
    HENKIB_SV_PROTRACK_CHAR.Selected[self.categoryID].isChecked = self:GetChecked()
    if (self:GetChecked()) then
        HENKIB_SV_PROTRACK_CHAR.Collapsed = false
    end
    H_PROTRACK.H_UpdateTracker()

end

function H_PROTRACK.H_AddSkillpoint(arg1)

    H_PROTRACK.H_UpdateProfTrackData()
    H_PROTRACK.H_UpdateTracker()

end

function  H_PROTRACK.pairsByKeys (t, f)
    local a = {}
    for n in pairs(t) do table.insert(a, n) end
    table.sort(a, f)
    local i = 0
    local iter = function ()
        i = i + 1
        if a[i] == nil then return nil
        else return a[i], t[a[i]]
        end
    end
    return iter
end

function H_PROTRACK.H_UpdateTracker()

    x = 10
    y = -35

    i = 0

    local list = {}

    for categoryID, profession in pairs(HENKIB_SV_PROTRACK_CHAR.Selected) do 
        
        if H_PROTRACK.Tracker.ListItem[categoryID] == nil then
            H_PROTRACK.H_CreateTrackerLine(profession)
        end

        if profession.isChecked and profession.isLoaded then
            list[profession.order] = profession
            i = i + 1
        end

        H_PROTRACK.Tracker.ListItem[profession.categoryID]:Hide() 

    end

    H_PROTRACK.Tracker.NoData:Hide()

    if HENKIB_SV_PROTRACK_CHAR.Collapsed then
        H_PROTRACK.Tracker:SetSize(250, 30)
        return false
    end

    if C_TradeSkillUI.GetCategories() == nil then
        H_PROTRACK.Tracker.NoData.Text:SetText("No data loaded, select a profession.")
        H_PROTRACK.Tracker:SetSize(250, 60)
        H_PROTRACK.Tracker.NoData:Show()
        return false
    end

    if (i == 0) then
        H_PROTRACK.Tracker.NoData.Text:SetText("No profession selected.")
        H_PROTRACK.Tracker:SetSize(250, 60)
        H_PROTRACK.Tracker.NoData:Show()
        return false
    end

    for order, profession in  H_PROTRACK.pairsByKeys(list) do 

            H_PROTRACK.Tracker.ListItem[profession.categoryID].name:SetText(profession.name)

            H_PROTRACK.Tracker.ListItem[profession.categoryID].skillPerHour:Hide()
            if (HENKIB_SV_PROTRACK_CHAR.Metrics[profession.categoryID] ~= nil) then
                if (HENKIB_SV_PROTRACK_CHAR.Metrics[profession.categoryID].skillPerHour ~= nil) then
                    H_PROTRACK.Tracker.ListItem[profession.categoryID].skillPerHour:SetText(HENKIB_SV_PROTRACK_CHAR.Metrics[profession.categoryID].skillPerHour.."/h")
                    H_PROTRACK.Tracker.ListItem[profession.categoryID].skillPerHour:Show()
                end
            end

            H_PROTRACK.Tracker.ListItem[profession.categoryID].skillPoints:SetText(profession.skillLineCurrentLevel.."/"..profession.skillLineMaxLevel)

            H_PROTRACK.Tracker.ListItem[profession.categoryID]:SetPoint("TOPLEFT", H_PROTRACK.Tracker, "TOPLEFT", 10, y)

            H_PROTRACK.Tracker.ListItem[profession.categoryID]:Show()  

            y = y - 15
        
    end

    H_PROTRACK.Tracker:SetSize(250, y*-1);

end

function H_PROTRACK.H_ShowTracker() 

    H_PROTRACK.Tracker:Show()
    HENKIB_SV_PROTRACK_CHAR.TrackerVisible = true

end

function H_PROTRACK.H_HideTracker() 

    H_PROTRACK.Tracker:Hide()
    HENKIB_SV_PROTRACK_CHAR.TrackerVisible = false

end

function H_PROTRACK.H_ToggleTracker()

    if H_PROTRACK.Tracker:IsVisible() then
        H_PROTRACK.H_HideTracker()
    else
        H_PROTRACK.H_ShowTracker()
    end

end

function H_PROTRACK.H_ToggleCollapse()

    if HENKIB_SV_PROTRACK_CHAR.Collapsed then
        HENKIB_SV_PROTRACK_CHAR.Collapsed = false
    else
        HENKIB_SV_PROTRACK_CHAR.Collapsed = true
    end

    H_PROTRACK.H_UpdateTracker();

end


function H_PROTRACK_H_StartProTrack()
     
    H_PROTRACK.H_StartProTrack()
end
